#!/bin/tclsh
########################################################################
#                        Mr V DirScript v2.0                           #
########################################################################
# Changes :                                                            #
#   - v2.0: Rewroted completly the script.                             #
#         : Added cds & affil array support                            #
#         : SQL Support                                                #
#         : dupeCheck exporter (CLEAN,UPDATE FLAGS)                    #
#         : Added socketBot support                                    #
########################################################################
# Features:                                                            #
# -directory Creation control                                          #
# -independent zones-control                                           #
# -multi-zones                                                         #
# -mp3zone compatible                                                  #
# -log feature                                                         #
# -dupeCheck dataBase exporter (OPTIONAL)                              #
########################################################################
# Notes:                                                               #
# Lo bro.. this is my dirScript.. the SQL Features is OPTIONAL in this #
# script.. but what it does.. ok.. it adds to your SQL 'dupeCheck'     #
# database the new dirs maked.. so.. the dataBase dont need to be in   #
# the localhost coz if configured properly the dataBase can be updated #
# by an external option every X minutes with the crontab. In all cases #
# any kind of dataBase should be used by the script TEXT or SQL..      #
# The database can be auto-cleaned callin the script with the 'CLEAN'  #
# flag. ex: 'vDirscript CLEAN'.                                        #
# For update the dataBase from the TEXT file to the SQL you must call  #
# the script with the 'DUMP' flag. ex: 'vDirscript DUMP'               #
# Oh god! if im correctly you can run your own dupecheck if you got a  #
# ring of sites or friends that runs some sections.. wohoo!            #
# We can call the script for delete an entry of the text file with the #
# 'DEL' flag. ex: 'vDirscript DEL <RELEASE>'                           #
# I Will try to include a 'web-frontend' in the next version ;) omg!   #
# I Did the script the most configurable as possible to fit everywhere #
#      Remember to report bugs to me @ my mail.. read bellow..         #
#  If you need custom scripts done, my services are always available.  #
########################################################################
# Dependencies:                                                        #
# -TCL 8.4 atleast                                                     #
# -SQL (Oracle,MySQL,Postgress..) (OPTIONAL)                           #
# -TCL-SQL (OPTIONAL)                                                  #
# -BRAiN to configure it..                                             #
########################################################################
# Author:                               Mr_V <vampirito@vampirito.com> #
#       Check out my latest scripts at www.grandis.nu/glftpd/          #
#                               Thanks Turranius for host it!          #
########################################################################
# siteName
set siteName "TC"
# glfTPD directory
set gldir "/glftpd"
# dirScript logo
set logo "\[${siteName}-DiRSCRiPT\]"
# glftpd log configuration
set dir(glftpd) "1"
# if enabled define the location of that log
set dir(gl_log) "/ftp-data/logs/glftpd.log"
# external dupe dataBase
set dir(db) "1"
# location of this file
set dir(db_file) "/ftp-data/logs/dirscript.db"
# socket Log (other type of siteBot) (Very easy.. get my vSAnnouncer)
# compatible with vSHub.
set dir(bot) "1"
# if enabled configure it
set bot(ip) "127.0.0.1"
set bot(port) "65533"
set bot(divider) "\^"
# dupeCheck the release ?
set dir(dupe) "1"
# SQL Features
set sql(status) "1"
set sql(host) "127.0.0.1"
set sql(login) "vcheck"
set sql(pass) "kcehcv99"
set sql(db) "vcheck"
set sql(table) "vDupecheck"
# For the dupeCheck engine we must check if the directory exists ?
# a good way to have the dupeDatabase cleaned of nuked releases
set sql(check_dirs) "1"
# if a dupe is found we allow to make the dir ?
# 1 not allow to make it! {NOTES: if i make the dir and i delete it later
# ..there can be problems.. coz the check is on it.. we can use the postdel
# script in this case to cleanup those things.
# 0 informs the user about the dupe but allow to make the dir
# (that doesnt happend if the dir is a Sample or a CD..)
set dir(bitch) "1"
# CLEANUP SETTINGS:
# how much days we store in the dBfile
set dir(days) "7"
####################### ZONES CONFIGURATION ############################
# Okey guys.. i tryed to make it LONG BUT NOT HARD.. using arrays      
# How the hell that shit works ?.. very easy take a look to the examples
# FIRST: DEFINE the ZONES NAME (all names in one)
# you can have configured it with a future section that will come later..
# so when is ready you only need to add the name to this:
set zones "iSO-UTiLS iSO-GaMES DiVX 0-DaY Mp3"
# 'zone' array:
# STRUCTURE: dir:dir:dir:dir
# eX: "/site/iSO/UTiLS:/site/HD2/iSO-UTiLS"
set zone(iSO-UTiLS) "/site/iSO/UTiLS/*"
# 'nallowed' array:
# STRUCTURE: *GLOB-STYLE-EXPRESSION*:REASON(1WORD_ONLY)
# eX: set nallowed(zone) {
#                *-iND:BANNED-GROUP
#               *BETA*:BETA-CRAP
#               }
# very easy..
set nallowed(iSO-UTiLS) {
    *-MAGE:BANNED-GROUP
    *BETA*:BETA
}
# 'allowed' array:
# STRUCTURE: *GLOB-STYLE-EXPRESSION*:REASON(1WORD_ONLY)
# the same of the 'nallowed' array but this care about what will be allowed
# this array is used for bitch a zone..
# eX: *-LND:LND-ALLOWED
#     *-FTL:FTL-ALLOWED
# to skip this array set it at '*'
set allowed(iSO-UTiLS) {
    *
}
# 'cds' array:
# STRUCTURE: <# of cds>:REASON
# eX: 4:MAX-4CDS
set cds(iSO-UTiLS) "2:MAX-2CDs"
# 'affil' array:
# if enabled the releases from those groups cant be uploaded on this section
# STRUCTURE: AFFIL AFFIL AFFIL AFFIL
# eX: 0-DAYGROUP iSOGRP1 MP3GRP1 MP3GRP2 MP3ELITE
set affil(iSO-UTiLS) "ISO"
# start again
set zone(iSO-GaMES) "/site/iSO/GaMES/*"
set allowed(iSO-GaMES) {
    *
}
set nallowed(iSO-GaMES) {
    *DOX*:DOX-PATCH
    *PATCH*:DOX-PATCH
    *BETA*:BETA-GaME
    *LINUX*:LiNUX-GaME
}
set cds(iSO-GaMES) "4"
set affil(iSO-GaMES) "MND"

set zone(DiVX) "/site/Movies/DiVX/*"
set allowed(DiVX) {
    *SPANISH*:SPANiSH
    *DIVX*:DiVX
    *XVID*:XViD
    *SCREENER*:Screener
    *VHS-RIP*:VHS-RiP
    *PROPER*:Proper-Release
}
set nallowed(DiVX) {
    *ENGLISH*:English-Movie
    *-iND:BANNED-GROUP
}
set zone(0-DaY) "/site/0-Day/*"
set allowed(0-DaY) {
    *
}
set nallowed(0-DaY) {
    *SOLARIS*:Solaris-Release
    *UNIX*:Unix-Release
    *IRIX*:IRiX-Release
    *-UX*:DG/HP-UX-Release
    *SCREENSAVER*:Screen-Saver
    *SCREEN-SAVER*:Screen-Saver
    *FREEWARE*:FreeWare
    *-iND:BANNED-GROUP
}
set zone(Mp3) "/site/Mp3/*"
# check this example to set the mp3Years
set allowed(Mp3) {
    *-03-*:2003-YEAR
    *-2003-*:2003-YEAR
    *-02-*:2002-YEAR
    *-2002-*:2002-YEAR
}
# Some examples to ban stuff on the Mp3 Zone
set nallowed(Mp3) {
    *-iND:BANNED-GROUP
    *-VLS-*:ViNYL
    *-Vinyl-*:ViNYL
    *-Vinyls-*:ViNYL
    *-CDM-*:CD-MAXi
    *-CDS-*:CD-SiNGLE
    VA_*:VARiOUS-ARTiST
    VA-*:VARiOUS-ARTiST
    *_Live_*:LiVESET
    *-Live-*:LiVESET
    *-Live_*:LiVESET
    *_Live-*:LiVESET
    *--*:RiA-RULES
    *__*:RiA-RULES
}
set cds(Mp3) "5"
########################################################################
# sql db connect
proc sqlConnect {} { global sql
    load /usr/lib/sql.so
    set sql(conn) [sql connect $sql(host) $sql(login) $sql(pass)]
    sql selectdb $sql(conn) $sql(db)
}
proc sqlDisconnect {} { global sql tcl_platform
    catch {sql endquery $sql(conn)}
    if {($tcl_platform(os) != "FreeBSD") && ($sql(conn) != "") && ([catch {sql disconnect $sql(conn)} err])} {
        puts "Error disconnecting dB"
    }
}
# subProc that sends msgs if the exist status is 2
proc putBad {data} { global logo
    puts "${logo} ${data}"
    set outStyle "1"
}

# subProc that sends msgs if the exit status is 0
proc putOk {data} { global logo
    puts "\#0${logo} ${data}\r"
    set outStyle "0"
}

# determines the type of msgs deppend of the future exit status
proc putOut {style data} { global logo outStyle
    if {[info exist outStyle]} {
        if {$outStyle == "1"} {
            putBad "$data"
            return 0
        }
        if {$outStyle == "0"} {
            putOk "$data"
            return 0
        }
    } else {
        if {$style == 0} {
            putOk "$data"
            return 0
        }
        if {$style == 1} {
            putBad "$data"
            return 0
        }
    }
}

# process that detects the exit status deppends of the msgs sended
# thats the proc that send the deniesDir to daemon
proc dir:exit {outStyle} {
    if {$outStyle == "1"} {
        exit 2
    }
    if {$outStyle == "0"} {
        exit 0
    }
}

# process that checks the textDB if it is a dupe
# exit deppends of 'bitch' mode and if the dupe is found
# those are the exit status:
# if $bitch == 1 && isdupe { 1 }
# if $bitch == 0 && isdupe { 0 }
# if !isdupe { 0 }
proc dir:dupe {dire} { global dir
    if {![file exist $dir(db_file)]} {
        return 0
    }
    set zoun [dir:getZone "$dire"]
    set of [open $dir(db_file) r]
    while {![eof $of]} {
        set line [gets $of]
        set zone [lindex $line 1]        
        set dirb [lindex $line 4]
        if {([string match "[string tolower $dire]" "[string tolower $dirb]"]) && ("$zoun" == "$zone") && ($line != "")} {
            set time [lindex $line 0]
            set useru [lindex $line 2]
            set groupu [lindex $line 3]
            set rela [join [lrange [split $dire "/"] end-1 end] /]
            set relb [join [lrange [split $dirb "/"] end-1 end] /]
            if {$dir(bitch) == 1} {
                set g "1"
            } else {
                set g "0"
            }
            putOut $g "        --=( Not Allowed )=--"
            putOut $g ""
            putOut $g "        oh no\! There is a dupe\!"
            putOut $g " $rela match with $relb"
            putOut $g " Uploaded by ${useru}(${groupu})"
	    if {[info exist time]} {
               if {($time != "") && ($time != 0)} {
	            putOut $g " Date: [clock format $time -format "%H:%M:%S %d/%m/%y"]"
               }
            } else {
               set time "0"
            }
            return "$g $time $useru $groupu"
        }
    }
    return 0
}        
# process that detects the zone from the dir
proc dir:getZone {dir} { global zone zones
    foreach stuff $zones {
        foreach name [split $zone($stuff) ":"] {
            if {[string match "$name" "$dir"]} {
                return "$stuff"
            }
        }
    }
    return 0
}

# process that checks if its allowed
# 0 if skip passed
# 0 <reason> if passed with reason (reason can be "")
# 1 not allowed
proc dir:allowed {dir} { global allowed
    set name [dir:getZone "$dir"]
    if {$name == "0"} {
        return 1
    }
    if {![info exist allowed(${name})]} {
        return 1
    }
    if {$allowed($name) == ""} {
        return 1
    }
    foreach rule $allowed($name) {
        set reason [lindex [split $rule ":"] 1]
        set rule [lindex [split $rule ":"] 0]
        if {[string match $rule $dir]} {
            return "1 $reason"
        }
    }
    return 0
}
# process that checks if its not-allowed
# 0 if skip passed
# 0 <reason> if passed with reason (reason can be "")
# 1 not allowed
proc dir:nallowed {dir} { global nallowed
    set name [dir:getZone "$dir"]
    if {$name == "0"} {
        return 0
    }
    if {![info exist nallowed(${name})]} {
        return 0
    }
    if {$nallowed($name) == ""} {
        return 0
    }
    foreach rule $nallowed($name) {
        set reason [lindex [split $rule ":"] 1]
        set rule [lindex [split $rule ":"] 0]
        if {[string match $rule $dir]} {
            return "1 $reason"
        }
    }
    return 0
}
# process that checks if its affil
# 0 if isnt an affil
# 1 if its an affil
proc dir:affil {dir} { global affil
    set name [dir:getZone "$dir"]
    if {$name == "0"} {
        return 0
    }
    if {![info exist affil(${name})]} {
        return 0
    }
    set relGrp [lindex [split "$dir" "-"] end]
    foreach group $affil($name) {
        if {"[string tolower $group]" == "[string tolower $relGrp]"} {
            return 1
        }
    }
    return 0
}
# process that dumps from the txtdB the info to the SQL
# for the dupeCheck engine
proc dumpSQL {} { global sql dir gldir siteName
    # BY DEFAULT WE ONLY TRY TO ADD INTO THE DB TODAY STUFF
    # CAN BE CHANGED HERE
    set sql(days) "1"
    set datemark [clock scan "$sql(days) days ago"]
    if {([file isdirectory $gldir]) && ([file exist "${gldir}$dir(db_file)"])} {
        set dir(db_file) "${gldir}$dir(db_file)"
    }
    if {![file exist $dir(db_file)]} {
        puts "-ERROR- DB FILE NOT FOUND FOR A CLEANUP"
        return 0
    }
    set of [open $dir(db_file) r]
    while {![eof $of]} {
        set line [gets $of]
        set date [lindex $line 0]
        set relDir [lindex $line 4]
        set invalid 0
        if {($sql(check_dirs) == 1) && (![file isdirectory $relDir]) && (![file isdirectory ${gldir}${relDir}])} {
            set invalid 1
        }
        set release [lindex [split [lindex $line 4] "/"] end]
        if {($invalid == 0) && ($date > $datemark) && (![string match -nocase "CD?" $release]) && (![string match -nocase "CD??" $release])} {
            set zone [lindex $line 1]
            set user [lindex $line 2]
            set group [lindex $line 3]
            catch {sql exec $sql(conn) "INSERT INTO $sql(table) VALUES ('$date', '$release', '$zone', '$user', '$group', '$siteName');"} err
            if {($err == "") || ($err == "0")} {
                puts "ADDED CORRECTLY $release ($zone - $date - $user / $group)"
            } else {
                puts "DUPLiCATE ENTRY.. skipped $release"
            }
        }
    }
    close $of
}
# process that adds the entry to the txtFile
# 0 if not saved
# 1 if saved
proc dir:txtdb {dirb} { global env dir
    set user "$env(USER)"
    set group "$env(GROUP)"
    set zone [dir:getZone "$dirb"]
    if {"$zone" == "0"} {
        return 0
    }
    if {(![file exist $dir(db_file)]) && (![file writable $dir(db_file)])} {
        return 0
    }
    set of [open $dir(db_file) a]
    set time [clock seconds]
    puts $of "$time $zone $user $group $dirb"
    close $of
    return 0
}
# process that checks the cds array stuff
# 0 if allowed
# <NUM CDS> <REASON> not allowed
# so.. if exit != 0 { not allowed }
proc dir:cds {dir} { global cds
    set name [dir:getZone "$dir"]
    if {$name == "0"} {
        return 0
    }
    if {![info exist cds(${name})]} {
        return 0
    }
    set numcds "[lindex [split $cds($name) ":"] 0]"
    set reason "[lindex [split $cds($name) ":"] 1]"
    if {[string match -nocase "*/CD\[[expr $numcds + 1]-9\]" [string toupper $dir]]} {
        return "$numcds MAX-${numcds}CDs"
    } else {
        return 0
    }
}
# show the rules of the X array in the X style
# it showed directly to stdout
proc putRules {style arreid name} { global allowed nallowed cds affil
    if {[info exist arreid($name)]} {
        foreach line $arreid($name) {
            putOut $style "$arreid \> [lindex [split $line ":"] end]"
        }
    }
}
# logs to file or socket deppending of the type & style of logging/function
# 0 - not logged
# 1 - logged correctly
proc log {type dirb reason} { global dir bot gldir env siteName
    set logo "\[\002$siteName\002-DiRSCRiPT\]"
    set user "$env(USER)"
    set group "$env(GROUP)"
    set zone [dir:getZone "$dirb"]
    set rel [lindex [split $dirb "/"] end]
    if {$dir(bot) == 1} {
        set style 1
    } else {
        set style 0
    }
    if {($style == 0) && ($dir(glftpd) == 0)} {
        return 0
    }
    if {($dir(glftpd) == 0) && ($style == 0) && (![file exist $dir(gl_log)]) && (![file writable $dir(gl_log)])} {
        return 0
    }
    switch $style {
        1 {
            set of [socket $bot(ip) $bot(port)]
            switch $type {
                nallowed {
                    puts $of "DIRSCRIPT$bot(divider)$logo oh\! \002$user\002 from \002$group\002 tryed to upload crap into the \002$zone\002 dir \>\> \002$rel\002 \<\< (REASON: \002$reason\002)"
                }
                cds {
                    puts $of "DIRSCRIPT$bot(divider)$logo ... mhhm.. looks like we got a nuke tryed to upload more cds of the allowed in the \002$zone\002 zone.. \>\> [lindex [split $dirb "/"] end-1] \<\< (REASON: \002$reason\002)"
                }
                affil {
                    puts $of "DIRSCRIPT$bot(divider)$logo ... something wrong should happend.. \002$user\002 from \002$group\002 tryed to upload \>\> \002$rel\002 \<\< in the \002$zone\002 dir.. but [lindex [split $rel "-"] end] is affil.."
                }
                dupe {
                    puts $of "DIRSCRIPT$bot(divider)$logo w00t\! \002$user\002 from \002$group\002 thinks that he can upload 0-month stuff.. tryed to upload \002$rel\002 on \002$zone\002 but was already uploaded.. DUPE\! (DETAiLS: $reason)"
                }
            }
            close $of
            return 1
        }
        2 {
            set of [open $dir(gl_log) r]
            set lf "[clock format [clock seconds] -format "%a %b %d %T %Y"]"
            puts $of "$lf \"DiRSCRIPT:\" \"$dir\" \"$user\" \"$group\" \"$type\" \"$zone\" \"$reason\""
            close $of
            return 1
        }
    }
    return 0
}
# process that cleanups the textdB
proc cleandB {} { global dir gldir
    if {([file isdirectory $gldir]) && ([file exist "${gldir}$dir(db_file)"])} {
        set dir(db_file) "${gldir}$dir(db_file)"
    }
    if {![file exist $dir(db_file)]} {
        puts "-ERROR- DB FILE NOT FOUND FOR A CLEANUP"
        return 0
    }
    set of [open $dir(db_file) r]
    set if [open $dir(db_file).tmp w]
    set daytrick [clock scan "$dir(days) days ago"]
    while {![eof $of]} {
        set line [gets $of]
        set timestamp [lindex $line 0]
        if {$timestamp > $daytrick} {
            puts $if "$line"
        }
    }
    close $of
    file delete "$dir(db_file)"
    file copy "$dir(db_file).tmp" "$dir(db_file)"
    file delete "$dir(db_file).tmp"
    file attributes "$dir(db_file)" -permissions rw-rw-rw-
}
# process that deletes a string from the dupedB
proc deldB {dirb} { global dir gldir
    if {([file isdirectory $gldir]) && ([file exist "${gldir}$dir(db_file)"])} {
        set dir(db_file) "${gldir}$dir(db_file)"
    }
    if {![file exist "$dir(db_file)"]} {
        puts "-ERROR- DB FILE NOT FOUND"
        return 0
    }
    set of [open $dir(db_file) r]
    set if [open $dir(db_file).tmp w]
    set daytrick [clock scan "$dir(days) days ago"]
    while {![eof $of]} {
        set line [gets $of]
        set timestamp [lindex $line 0]
        set dira [lindex $line 4]
        if {($timestamp > $daytrick) && (![string match "$dirb" "$dira"])} {
            puts $if "$line"
        }
    }
    close $of
    file delete "$dir(db_file)"
    file copy "$dir(db_file).tmp" "$dir(db_file)"
    file delete "$dir(db_file).tmp"
    file attributes "$dir(db_file)" -permissions rw-rw-rw-
}
# checks current dir
proc dir:currDir {dir} {
	set stuff [glob -nocomplain -path [pwd]/ * -types d]
	foreach name $stuff {
		if {"[string tolower $name]" == "[string tolower $dir]"} {
			return 1
		}
	}
	return 0
}
# MAiN PROCESS
proc dir:main {} { global logo env allowed nallowed cds affil zones zone argv sql
    set option "[string tolower [lindex $argv 0]]"
    if {$option == "clean"} {
        cleandB
        return 0
    }
    if {$option == "del"} {
        deldb [lindex $argv 1]
        return 0
    }
    if {($option == "dump") && ($sql(status) == 1)} {
        sqlConnect
        dumpSQL
        #sqlDisconnect
        return 0
    }
    puts "$logo vDirscript.. checking.."
    # as default the directory pass the dirscript
    set passed 1
    # DEFiNE CORRECTLY THE COMPLETE PATH
    set dir "[pwd]/[lindex $argv 0]"
    set currdir [dir:currDir "$dir"]
    if {$currdir == 1} {
         set passed 0
    }
    # DEFiNE CORRECTLY THE ZONENAME
    set zoneName "[dir:getZone "$dir"]"
    # check if its not allowed
    set nalloInfo [dir:nallowed "$dir"]
    set nallowez [lindex $nalloInfo 0]
    set nallores [lindex $nalloInfo 1]
    if {($passed == 1) && ($nallowez == 1)} {
        putOut 1 "        --=( Not Allowed )=--"
        putOut 1 ""
        putOut 1 " That kind of stuff is not allowed here"
        putRules 1 nallowed $zoneName
        log "nallowed" "$dir" "$nallores"
        set passed 0
    }
    # check if its allowed
    set alloInfo [dir:allowed "$dir"]
    set allowez [lindex $alloInfo 0]
    set allores [lindex $alloInfo 1]
    if {($passed == 1) && ($allowez == 0)} {
        putOut 1 "        --=( Not Allowed )=--"
        putOut 1 ""
        putOut 1 " Not pass the allowed rules"
        putRules 1 allowed $zoneName
        set passed 0
    }
    # check if its an affil
    set affiled [dir:affil "$dir"]
    if {($passed == 1) && ($affiled == 1)} {
        putOut 1 "        --=( Not Allowed )=--"
        putOut 1 ""
        putOut 1 "   This group is an affil"
        putOut 1 "  Something should happend.. "
        putOut 1 "  please informs the siteops"
        set passed 0
        log "affil" "$dir" "is AFFiL\!"
    }
    # check if its a dupe
    set dupeInf [dir:dupe "$dir"]
    set dupe [lindex $dupeInf 0]
    set dupede [lrange $dupeInf 1 end]
    # by default: 01-01-03 by root/STAFF
    if {$dupede != ""} {
        set dupedet "[clock format [lindex $dupede 0] -format "%d/%m/%y"] by [lindex $dupede 1]/[lindex $dupede 2]"
    } else {
        set dupedet "NO-DUPE-iNFO"
    }
    if {($passed == 1) && ($dupe == 0)} {
        dir:txtdb "$dir"
    } elseif {($passed == 1) && ($dupe == 1)} {
        set passed 0
        log "dupe" "$dir" "$dupedet"
    }
    # check if its a CDs dir
    set cdz [dir:cds "$dir"]
    set cdzres [lindex $cdz 1 end]
    set cdz [lindex $cdz 0]
    if {($cdz != 0) && ($passed == 1)} {
        putOut 1 "        --=( Not Allowed )=--"
        putOut 1 ""
        putOut 1 "      Max $cdz CDs per release"
        set passed 0
        log "cds" "$dir" "$cdzres"
    }
    if {$passed == 0} {
	putOut 1 " vDirscript: denied\!"
	dir:exit 1
    } else {
	putOut 0 " vDirscript: allowed\!"
	dir:exit 0
    }
}
dir:main

